#include <iostream>
#include <fstream>
#include "image.h"
#include "select.h"
#include <vector>
#include <string>
#include <stack>



ImageColor::ImageColor()
{
  data=0;

}
ImageColor::ImageColor(std::istream &file_in) {
   data = 0;
   width=height=numpixels=0;
   read_pgm(file_in);
 
  
}

ImageColor::~ImageColor()
{delete [] data;}  

 
bool ImageColor::read_pgm(std::istream &fich_in) {
 
  width = height = 0; data = 0;
 
  fich_in.getline(line,100);

  fich_in >> width >> height >> maxvalue;
  
  numpixels=width*height;
  
  data = new char[numpixels];
  
  fich_in.read(data,numpixels);
  
  return true;
}



void ImageColor::process_image(std::vector<std::string> &idx_box,int const Min_Box,int const k)
{
  
  int p;
 
  for(int m=0;m<height;m++)
    for(int n=0;n<width;n++)
	{
	  p=m*width+n;
	  
	  if(data[p]==0)
	    {
	      n_pixels=0;
	      minX=maxX=n;
	      minY=maxY=m;
	      bp.clear();
			
	      std::string caja;
	    	      
	      create_box(p); 
	      
	      //creating box of string 
	      caja.append((maxX-minX+1)*
			  (maxY-minY+1),'1');
	      
	      
	      // black pixels in the string
	      for(int it=0;it<(int)bp.size();it++)
		{
		  caja[(bp[it]/width-minY)*(maxX-minX+1)+((bp[it]%width)-minX)]='0';
		}
	      // checking the noise boxes
	      if(n_pixels>Min_Box)
		{
		  idx_box.push_back(caja);
		  		  
		}	      
	  }
	}
   
	select(idx_box,0,(int)idx_box.size()-1,k);
	if((int)idx_box.size()-1>k+1)
	{
	  idx_box.erase(idx_box.begin()+k+1,idx_box.end()-1);
	}
	
}

void ImageColor::create_box(int p)
{
	

  pila.push(p);

  data[p]=-1;

  while(!pila.empty())
    { 
      p=pila.top();
      
      pila.pop();
      n_pixels++;
      
      if(minX>p%width)minX=p%width;
      if(maxX<p%width)maxX=p%width;
      if(minY>p/width)minY=p/width;
      if(maxY<p/width)maxY=p/width;

      bp.push_back(p);

      //delete the black pixel
      
  
      
 //check for black pixel in 8-directions
  
  
      if(p%width+1<width && p/width-1>0 && data[p-width+1]==0 )
	{
	  pila.push(p-width+1);
	  data[p-width+1]=-1;
	}
      
      
      
      if(p%width+1<width && p/width+1<height && data[p+width+1]==0)
	{	
	  pila.push(p+width+1);
	  data[p+width+1]=-1;
	  
	}	
      
      
      
      if(p%width-1>0 && p/width-1>0 && data[p-width-1]==0)
	{
	  pila.push(p-width-1);
	  data[p-width-1]=-1;
	  
	}
      
      
      if(p%width-1>0 && p/width+1<height && data[p+width-1]==0)
	{
	  pila.push(p+width-1);
	  data[p+width-1]=-1;
	  
	}
      
      if(p%width+1<width && data[p+1]==0)
	{
	  pila.push(p+1);
	  data[p+1]=-1;
	  
	}
      
      if(p%width-1>0 && data[p-1]==0)
	{
	  pila.push(p-1);
	  data[p-1]=-1;
	}
      
      if(p/width+1<height && data[p+width]==0)
	{
	  pila.push(p+width);
	  data[p+width]=-1;
	  
	}
      
      if(p/width-1>0 && data[p-width]==0)
	{ 
	  pila.push(p-width);
	  data[p-width]=-1;
	  
	}
      
    }
}

