#include "select.h"
#include <iostream>
#include <vector>
#include <string>



inline void swap(std::string &a,std::string &b)
{

  std::string tmp(a);
  a.clear();
  a.append(b);
  b.clear();
  b.append(tmp);
}
inline std::string med3(std::vector<std::string> &A,int low, int high){

  int cnt = (low+high)/2;

  if (strcmp(A[low].c_str(),A[cnt].c_str())>0)  swap(A[low],A[cnt]);
 
  if (strcmp(A[low].c_str(),A[high].c_str())>0) swap(A[low],A[high]);
 
  if (strcmp(A[cnt].c_str(),A[high].c_str())>0) swap(A[cnt],A[high]);
 
  swap(A[cnt],A[high-1]);

 return A[high-1];

}

inline int partition(std::vector<std::string> &A, int low, int high)
{
  int izq,der;
  std::string piv(med3(A,low,high)); 
	
 
  if (low+1 >= high) return low;

  // precondition: low+1 < high
  
  izq=low;
  der=high-1;
  do {
    
	do {
		izq++; 
	}while(strcmp(A[izq].c_str(),piv.c_str())<0);
    
	do {

      der--;
	}while(strcmp(A[der].c_str(),piv.c_str())>0);

    swap(A[izq],A[der]);

  }while (izq<der);

  swap(A[izq],A[der]);
  swap(A[izq],A[high-1]);

  return izq;

}

std::string select(std::vector<std::string> &A, int p,int r, int k)
{

	int q;
	
	while(p<r)
	{
		q=partition(A,p,r);
		if(k<=q){r=q;}
		 else{p=q+1;}
	}
	
	return A[p];
}




